<template>
    <div class="default-main">
        <TableHeader ref="tableHeaderRef">
            <template #select>
                <el-form-item label="装置型号:">
                    <el-select v-model.trim="tableStore.table.params.devType" placeholder="请选择装置型号" clearable>
                        <el-option v-for="item in DevTypeOptions" :key="item.id" :label="item.name"
                            :value="item.id"></el-option>
                    </el-select>
                </el-form-item>
            </template>
            <template #operation>
                <el-button :icon="Plus" type="primary" @click="addMenu" class="ml10">新增版本</el-button>
            </template>
        </TableHeader>
        <Table ref="tableRef" />
        <PopupVersion ref="popupVersionRef" v-if="showPopup"></PopupVersion>
    </div>
</template>
<script setup lang="ts">
import { ref, onMounted, provide } from 'vue'
import TableStore from '@/utils/tableStore'
import Table from '@/components/table/index.vue'
import TableHeader from '@/components/table/header/index.vue'
import { delCsDictData } from '@/api/system-boot/csDictData'
import { ElMessage } from 'element-plus'
import { queryByCode, queryByid } from '@/api/system-boot/dictTree'
import { useDictData } from '@/stores/dictData'
import PopupVersion from '@/views/govern/manage/basic/popupVersion.vue'
import { Plus } from '@element-plus/icons-vue'
import { auditEdData } from '@/api/cs-device-boot/edData'

defineOptions({
    name: 'govern/manage/basic/version'
})
const popupVersionRef = ref()
const dictData = useDictData()
const showPopup = ref(false)
const DevTypeOptions = ref()
const tableHeaderRef = ref()

const tableStore = new TableStore({
    url: '/cs-device-boot/edData/queryEdDataPage',
    method: 'POST',
    column: [
        { title: '装置型号', field: 'devTypeName' },
        { title: '版本号', field: 'versionNo' },
        { title: '版本协议', field: 'versionAgreement' },
        { title: '版本日期', field: 'versionDate' },
        { title: '归档日期', field: 'updateTime' },
        { title: '描述', field: 'description' },
        {
            title: '状态', field: 'status', render: 'tag',
            custom: {
                1: 'error',
                0: 'success',

            },
            replaceValue: {
                1: '禁用',
                0: '启用',

            }
        },
        {
            title: '操作',
            align: 'center',
            width: '180',
            render: 'buttons',
            buttons: [
                {
                    name: 'edit',
                    title: '编辑',
                    type: 'primary',
                    icon: 'el-icon-EditPen',
                    render: 'basicButton',
                    click: row => {
                        popupVersionRef.value.open('编辑版本', row)
                    }
                },
                {
                    name: 'edit',
                    title: '启用',
                    type: 'primary',
                    icon: 'el-icon-Open',
                    render: 'basicButton',
                    disabled: row => {
                        return row.status == 1
                    },
                    click: row => {
                        auditEdData({
                            id: row.id,
                            status: 1
                        }).then((res: any) => {
                            ElMessage.success('启用成功')
                            tableStore.index()
                        })
                    }
                },
                {
                    name: 'del',
                    title: '禁用',
                    type: 'danger',
                    icon: 'el-icon-SwitchButton',
                    render: 'confirmButton',
                    popconfirm: {
                        confirmButtonText: '确认',
                        cancelButtonText: '取消',
                        confirmButtonType: 'danger',
                        title: '确定禁用吗？'
                    },
                    disabled: row => {
                        return row.status == 0
                    },
                    click: row => {
                        auditEdData({
                            id: row.id,
                            status: 0
                        }).then((res: any) => {
                            ElMessage.success('禁用成功')
                            tableStore.index()
                        })
                    }
                }
            ]
        }
    ],
    loadCallback: () => {
        tableStore.table.data.forEach((item: any) => {
            item.statusName = item.status == 1 ? '禁用' : '启用'
            for (let key in item) {
                if (typeof item[key] !== 'number') {
                    item[key] = item[key] || '/'
                }
            }
        })
    }
})
queryByCode('Device_Type').then(res => {
        const id = res.data.id
        queryByid(id).then(res1 => {
            res1.data.map((item: any, index: any) => {
                if (item.pid == id) {
                    res1.data.splice(index, 1)
                }
            })
            console.log("🚀 ~ res1.data.map ~ res1.data:", res1.data)

            DevTypeOptions.value = res1.data

        })
    })
tableStore.table.params.devType = ''
provide('tableStore', tableStore)
onMounted(() => {
   
    tableHeaderRef.value.onComSearch()
})
const addMenu = () => {
    showPopup.value = true
  setTimeout(() => {
    popupVersionRef.value.open('新增版本')
  }, 100)
}
</script>
